// Untahris (Common Playground)
// copyright (C) 2006 longuens@users.sourceforge.net
// Released under GNU General Public License (see the file COPYING)
// --------------------------------------------------------------
// Worm.

#define NOROPE -999 // rx is set to this value if we have no ninja rope

struct OWorm : TPlayObject {
  public:
  int x;
  int y;
  int dx;
  int dy;
  
  int rx;
  int ry;
  int drx;
  int dry;
  
  int dir;
  bool faceLeft;
  bool onFloor;
  
  bool dead;
  
  int lastKey;
  
  OWorm(int _owner, int _x, int _y) : 
    x(Ctr(_x)), y(Ctr(_y)) {
    owner = _owner;
    time = g.time;
    dx = 0; dy = 0; dir = 45;
    rx = NOROPE;
    faceLeft = _x > g.sizeX / 2;
    lastKey = 0;
    g.objects.push_back(this);
    dead = false;
    }
  
  OWorm(TBuffer &b) {
    b.get(owner); 
    b.get(x); b.get(y);
    b.get(dx); b.get(dy);
    b.get(rx); b.get(ry);
    b.get(drx); b.get(dry);
    b.get(time); b.get(dir);
    b.get(faceLeft);
    b.get(onFloor);
    b.get(lastKey);
    dead = false;
    }
  void save(TBuffer &b) {
    b.putChar(12);
    b.put(owner); 
    b.put(x); b.put(y);
    b.put(dx); b.put(dy);
    b.put(time); b.put(dir);
    b.put(faceLeft);
    b.put(onFloor);
    b.put(lastKey);
    }

  int oo;
  
  bool testBlock(int x, int y) {
    int nx = DeCtr(x);
    int ny = DeCtr(y);
    if(nx<0) nx = 0;
    if(ny<0) ny = 0;
    if(nx>g.sizeX-1) nx = g.sizeX-1;
    if(ny>g.sizeY-1) ny = g.sizeY-1;
    CellType m = bigType(nx, ny);
    oo = g.owner[ny][nx];
    if(m != cFree) {
      switch(m) {
        case cBonusLevel:
          d.playSoundAt(d.sndBlue, nx, ny);
          ow()->level += 10;
          ow()->score += scoreGain() * 10;
          break;
        case cBonusScore: 
          d.playSoundAt(d.sndGreen, nx, ny);
          ow()->typeval += 1000;
          ow()->score += scoreGain();
          break;
        case cBonusAmmo:
          d.playSoundAt(d.sndRed, nx, ny);
          ow()->ammo += 10;
          ow()->score += scoreGain();
          break;
        }
      placeBigRandomly(m, 0);
      clearBig(nx, ny, cFree, 0);
      }
    if(g.map[ny][nx] == cFree) return false;
    if(g.map[ny][nx] == cExplosion || g.map[ny][nx] == cSnakeHead ||
       g.map[ny][nx] == cSnakeTRON || 
       g.map[ny][nx] == cTetris) {
      if(!dead) {
        d.playSoundAt(d.sndDeath, nx, ny);
        dead = true; 
        killedBy(oo);
        }
      return true;
      }
    return true;
    }
  
  bool digAt(int x, int y) {
    if(x<0) x = 0;
    if(y<0) y = 0;
    if(x>g.sizeX-1) x = g.sizeX-1;
    if(y>g.sizeY-1) y = g.sizeY-1;
    destroyAt(x, y, owner);
    }
  
  bool blockedAt(int nx, int ny) {
    bool b;
    b =  testBlock(nx - 128, ny - 512);
    b |= testBlock(nx - 128, ny + 511);
    b |= testBlock(nx + 128, ny - 512);
    b |= testBlock(nx + 128, ny + 511);
    return b;
    }
  
  int adjustDir() {
    if(faceLeft) return (360 - dir) % 360;
    return dir;
    }
  
  void go() {
    dy += 12;
    if(g.pl[owner]->key[keyUp]) dir -= 10;
    if(g.pl[owner]->key[keyDown]) dir += 10;
    if(g.pl[owner]->key[keyUp] && g.pl[owner]->key[keyDown]) 
      if(lastKey == keyUp) dir--; else dir++;
    if(dir < 0) dir = 0;
    if(dir > 180) dir = 180;
    if(g.pl[owner]->key[keyAir] && onFloor) {
      dy = -384;
      }
    if(g.pl[owner]->key[keyLeft]) {
      faceLeft = true;
      dx -= 12;
      if(onFloor) dx -= 24;
      }
    if(g.pl[owner]->key[keyRight]) {
      faceLeft = false;
      dx += 12;
      if(onFloor) dx += 24;
      }
    bool b = false;
    int oo2 = ow()->index;
    
    if(rx != NOROPE) {
      bool hooked = false;

      int dist = int(hypot(rx-x, ry-y));
      if(dist > 40 * 1024) rx = NOROPE;
      else {
        int nrx = DeCtr(rx);
        int nry = DeCtr(ry);
        if(nrx<0) nrx = 0;
        if(nry<0) nry = 0;
        if(nrx>g.sizeX-1) nrx = g.sizeX-1;
        if(nry>g.sizeY-1) nry = g.sizeY-1;
        if(g.map[nry][nrx] != cFree)
          hooked = true;
        }
      
      TPlayObject* ohook = NULL;
      if(!hooked) {
        for(int o=0; o<size(g.objects); o++) if(g.objects[o])
          if(g.objects[o] != this)
          if(g.objects[o]->catchesRope(rx, ry)) ohook = g.objects[o];
        if(ohook) hooked = true;
        }
      
      if(hooked) {
        drx = 0;
        dry = 0;
        int pull = 0;
        if(dist > 10 * 1024 || g.pl[owner]->key[keyAir]) {
          int ddx = ((rx - x) * 18) / dist;
          int ddy = ((ry - y) * 18) / dist;
          dx += ddx;
          dy += ddy;
          if(ohook) ohook->pullRope(rx, ry, drx, dry, ddx, ddy);
          }
        else if(ohook) ohook->pullRope(rx, ry, drx, dry, 0, 0);
        }
      else rx += drx, ry += dry, dry += 12;
      }

    if(blockedAt(x+dx, y)) dx = 0; else x += dx;
    if(blockedAt(x, y+dy)) {
      onFloor = dy > 0;
      dy = 0, dx = dx * 3/4;
      y = Ctr(DeCtr(y));
      }
    else y += dy, onFloor = false;
    
//  dx *= 255/256;
//  dy *= 255/256;
    
    time += spd();
    }
  void draw() {
    int adir = adjustDir();
    DIc(icWorm).drawAtCentered(CTG(x), CTG(y));
    DIc(icBazooka).drawAtRotated(CTG(x), CTG(y), degx[adir], degy[adir]);
    if(rx != NOROPE)
      for(int p=0; p<400; p++)
        d.putpix(CTG(x+(rx-x)*p/400), CTG(y+(ry-y)*p/400), ow()->color);
    }
  void reactToKey(PlayerKey pk, bool pressed) {
    if(!pressed) return;
    int adir = adjustDir();

    if(pk == keyUp || pk == keyDown) lastKey = pk;

    if(pk == keyFire && ow()->useAmmo(2)) {
      d.playSoundAt(d.sndShoot, DeCtr(x), DeCtr(y));
      new OBullet(owner, x + degx[adir] * 8, y + degy[adir] * 8, 
        dx/spd() + (degx[adir] * bulletSpeed()) / 128, dy/spd() + (degy[adir] * bulletSpeed()) / 128);
      }

    if(pk == keyEarth) {
      int nx = DeCtr(x);
      int ny = DeCtr(y);
      d.playSoundAt(d.sndHit, nx, ny);
      digAt(nx, ny);
      if(dir > 22 && dir < 158) if(faceLeft) nx--; else nx++;
      digAt(nx, ny);
      if(dir < 67) ny--;
      if(dir > 113) ny++;
      digAt(nx, ny);
      }

    if(pk == keyWater) {
      if(rx == NOROPE) {
        d.playSoundAt(d.sndShoot, DeCtr(x), DeCtr(y));
        rx = x + degx[adir] * 8;
        ry = y + degy[adir] * 8;
        drx = dx + (degx[adir] * bulletSpeed() * spd()) / 128;
        dry = dy + (degy[adir] * bulletSpeed() * spd()) / 128;
        }
      else rx = NOROPE;
      }
    }
  bool reactToThruster(OThruster *enemy) {
    if(calcDistance(x-enemy->x, y-enemy->y) < 8*128 + 512) {
      d.playSoundAt(d.sndDeath, DeCtr(x), DeCtr(y));
      int oe = enemy->owner;
      killedBy(oe);
      return true;
      }
    return false;
    }
  bool smashedByBall(OBall *enemy) {
    if(calcDistance(x-enemy->x, y-enemy->y) < 512 + 512) {
      d.playSoundAt(d.sndDeath, DeCtr(x), DeCtr(y));
      killedBy(enemy->owner);
      return true;
      }
    return false;
    }
  bool reactToBullet(OBullet *bullet) {
    if(calcDistance(x-bullet->x, y-bullet->y) < 512) {
      d.playSoundAt(d.sndDeath, DeCtr(x), DeCtr(y));
      killedBy(bullet->owner);
      return true;
      }
    return false;
    }
  bool catchesRope(int rx, int ry) {
    if(calcDistance(x-rx, y-ry) < 512) {
      return true;
      }
    return false;
    }
  void pullRope(int& rx, int& ry, int &drx, int &dry, int ddx, int ddy) {
    rx = x; ry = y; drx = dx; dry = dy;
    dx -= ddx; dy -= ddy;
    }
  };

